unit NChar;

interface

uses NGlob,
     Dos,
     NGraph;

const
  Xbeg: Integer = 0;
  Xend: Integer = 39;
  Ybeg: Integer = 0;
  Yend: Integer = 24;
  Xcur: Integer = 0;
  Ycur: Integer = 0;
  TxtColor: Byte = 15;
  TxtBkGr: Byte = 0;

type
  PTextChar = ^TTextChar;
  TTextChar = record
    Simble: Byte;
    Attr: Byte;
  end;
  PFontChar = ^TFontChar;
  TFontChar = array [1..8] of Byte;
  PFont = ^TFont;
  TFont = array [1..256] of TFontChar;

var
  FontPtr: PFont;

procedure TBar (X, Y : Word);
procedure TChar (X, Y, CharCode: Word);
procedure TCur (X, Y: Word);
procedure TBChar (X, Y, CharCode: Word);
procedure TWriteLn (St: String);
procedure TWrite (St: String);
procedure TGoTo (X, Y: Integer);
procedure GetOFont;
procedure GetNFont (FlNm: PathStr);
procedure CloseFont;

implementation

procedure TCur (X, Y: Word); assembler;
asm
  les  di, ActBlPtr
  mov  ax, 8
  mov  bx, Y
  mul  bx
  add  ax, 7
  mov  bx, ActBX
  mul  bx
  add  di, ax
  mov  ax, 8
  mov  bx, X
  mul  bx
  add  di, ax
  mov  al, TxtColor
  mov  cx, 8
  rep  stosb
end;

procedure TBar (X, Y: Word); assembler;
asm
  les  di, ActBlPtr
  mov  ax, 8
  mov  bx, ActBX
  mul  bx
  mov  bx, Y
  mul  bx
  add  di, ax
  mov  ax, 8
  mov  bx, X
  mul  bx
  add  di, ax

  mov  al, TxtBkGr
  mov  dx, 8
@@NxtByte:
  mov  cx, 8
  rep  stosb
  add  di, ActBX
  sub  di, 8
  dec  dx
  cmp  dx, 0
  jg   @@NxtByte
end;

procedure TChar (X, Y, CharCode: Word);
var
  TCol: Byte;
  IncX: Word;
begin
  TCol := TxtColor;
  IncX := ActBX - 8;
  asm
    push ds
    les  di, ActBlPtr
    mov  ax, 8
    mov  bx, ActBX
    mul  bx
    mov  bx, Y
    mul  bx
    add  di, ax
    mov  ax, 8
    mov  bx, X
    mul  bx
    add  di, ax

    lds  si, FontPtr
    mov  ax, 8
    mov  bx, CharCode
    mul  bx
    add  si, ax

    mov  bl, TCol
    mov  dx, 8
@@NxtByte:
    mov  cx, 8
    mov  al, 10000000b
    mov  ah, byte ptr ds:[si]
@@NxtPix:
    test ah, al
    je   @@Hole
    mov  byte ptr es:[di], bl
@@Hole:
    shr  al, 1
    inc  di
    loop @@NxtPix
    add  di, IncX
    inc  si
    dec  dx
    cmp  dx, 0
    jg   @@NxtByte
    pop  ds
  end;
end;

procedure TBChar (X, Y, CharCode: Word);
begin
  TBar (X, Y);
  TChar (X, Y, CharCode);
end;

procedure TWriteLn (St: String);
var
  i: Integer;
begin
  for i:=1 to Byte (St[0]) do begin
    TBar (Xcur, Ycur);
    TChar (Xcur, Ycur, Byte (St[i]));
    Inc (Xcur);
  end;
  Xcur := Xbeg;
  Inc (Ycur);
end;

procedure TWrite (St: String);
var
  i: Integer;
begin
  for i:=1 to Byte (St[0]) do begin
    TBar (Xcur, Ycur);
    TChar (Xcur, Ycur, Byte (St[i]));
    Inc (Xcur);
  end;
end;

procedure TGoTo (X, Y: Integer);
begin
  Xcur := X;
  Ycur := Y;
end;

procedure GetOFont;
var
  R: Registers;
begin
  R.AX := $1130;
  R.BH := 3;
  Intr ($10, R);
  FontPtr := Ptr (R.ES, R.BP);
end;

procedure GetNFont (FlNm: PathStr);
var
  NumRead: Word;
  Handle: File;
begin
  Assign (Handle, FlNm);
  ReSet (Handle, 1);
  if IOResult <> 0 then ErrMsg ('Font not found '+ FlNm);
  TGetMem (Pointer (FontPtr), SizeOf (TFont));
  BlockRead (Handle, FontPtr^, SizeOf (TFont), NumRead);
  if NumRead <> SizeOf (TFont) then ErrMsg ('Reading error in '+ FlNm);
  Close (Handle);
end;

procedure CloseFont;
begin
  FreeMem (FontPtr, SizeOf (TFont));
end;

end.
