uses Graph, Crt;

type
  TLoc = record
    X, Y, Z: Real;
  end;
  TLocArr = array [1..1024] of TLoc;
  PLocArr = ^TLocArr;

  TPln = record
    p: array [1..3] of Word;
    Dist: Real;
  end;
  TPlnArr = array [1..1024] of TPln;
  PPlnArr = ^TPlnArr;

  TSc = record
    X, Y: Integer;
  end;
  TScArr = array [1..1024] of TSc;
  PScArr = ^TScArr;

const
  GrToRad: Real = 3.1416/180;        { ॢ ࠤᮢ  ࠤ }
  GD: Integer = 3;                   { ᪨ ० }
  GM: Integer = 1;
  VPage0: Pointer = Ptr ($A000, 0);  { ⥫  ࠭ }
  VPage1: Pointer = Ptr ($A800, 0);
  RLook: TLoc = (X : 0; Y : 25; Z :-550);
  LLook: TLoc = (X : 0; Y : -25; Z :-550);

  PirIniPoi: array [1..5] of TLoc = ({ 窨 ࠬ             }
  (X : 0; Y : 50; Z :-50),
  (X : 0; Y : 50; Z : 50),
  (X : 0; Y :-50; Z : 50),
  (X : 0; Y :-50; Z :-50),
  (X :90; Y :  0; Z :  0)
  );

  PirPln: array [1..4] of TPln = (   { ࠭ ࠬ             }
  (p : (1,2,5); Dist : 0),
  (p : (2,3,5); Dist : 0),
  (p : (3,4,5); Dist : 0),
  (p : (4,1,5); Dist : 0)
  );

var
  Look: TLoc;                        {  ⥫      }
  PirPoi: TLocArr;                   {  ᨢ 祪   }
  PirSc: TScArr;                     { ᨢ 祪  ࠭     }

function Xplan ( X, Z: Real): Integer;
begin
  Xplan := Trunc (Look.Z*X / (Look.Z-Z));
end;

function Yplan ( Y, Z: Real): Integer;
begin
  Yplan := Trunc (Look.Z*Y / (Look.Z-Z) + Look.Y);
end;

procedure OnScreen ( X, Y: Integer; var ScrX, ScrY: Integer);
{ न 祪  ࠭ }
begin
  ScrX := Trunc (Y*1.3 + 320);
  ScrY := 175 - X;
end;

procedure FormPoi (Risk, dX, dY, dZ: Integer;
                   IniPoi, Poi: PLocArr; NPoi: Word);
{ 稢 窨 }
var
  i: Integer;
  CosA, SinA: Real;
  A: Real;
begin
  A := Risk*GrToRad;
  CosA := Cos (A);
  SinA := Sin (A);
  for i:=1 to NPoi do
    with IniPoi^[i] do begin
      Poi^[i].X := X + dX;
      Poi^[i].Z := Z * CosA - Y * SinA + dZ;
      Poi^[i].Y := Z * SinA + Y * CosA + dY - Look.Y;;
    end;
end;

procedure FormScPoi (Poi: PLocArr; ScPoi: PScArr; NPnt: Word);
{ ⠥  祪  ࠭ }
var
  i: Integer;
begin
  for i:=1 to NPnt do
    with Poi^[i] do
      OnScreen ( Xplan (X, Z), Yplan (Y ,Z), ScPoi^[i].X, ScPoi^[i].Y);
end;

procedure DrawPlan (ScPoi: PScArr; Pln: PPlnArr; NPln: Word; Color: Byte);
{ 㥬 ࠭ }
var
  i, j: Integer;
begin
   for i:=1 to NPln do begin
     for j:=1 to 2 do begin
       Port [$3C4] := 2;
       Port [$3C5] := Color;
       Line (ScPoi^[Pln^[i].p[j]].X, ScPoi^[Pln^[i].p[j]].Y,
             ScPoi^[Pln^[i].p[j+1]].X, ScPoi^[Pln^[i].p[j+1]].Y);
     end;
     Port [$3C4] := 2;
     Port [$3C5] := Color;
     Line (ScPoi^[Pln^[i].p[3]].X, ScPoi^[Pln^[i].p[3]].Y,
           ScPoi^[Pln^[i].p[1]].X, ScPoi^[Pln^[i].p[1]].Y);
   end;
end;

procedure Show;
{ 뢠  ࠭ }
begin
  Port [$3CE] := 5;
  Port [$3CF] := 1;
  Move (VPage1^, VPage0^, 80*350);
  Port [$3CE] := 5;
  Port [$3CF] := 0;
end;

var
  Ch: Char;
  i, j: Integer;

begin
  InitGraph (GD, GM, '');
  SetActivePage (1);
  j:=150;
  repeat
  for i:=0 to 35 do
    begin
      j := i * 10;
      SetFillStyle (1, 0);
      Bar (0, 0, 639, 349);
      {  ࠢ  }
      Look := RLook;
      FormPoi (j, -60, 0, -250+(700-j*2), @PirIniPoi, @PirPoi, 5);
      FormScPoi (@PirPoi, @PirSc, 5);
      SetColor (4);
      DrawPlan (@PirSc, @PirPln, 4, 4);
      {    }
      Look := LLook;
      FormPoi (j, -60, 0, -250+(700-j*2), @PirIniPoi, @PirPoi, 5);
      FormScPoi (@PirPoi, @PirSc, 5);
      SetColor (1);
      DrawPlan (@PirSc, @PirPln, 4, 1);

      Show;
    end;
    Delay (1000);
  until KeyPressed;
  Ch := ReadKey;
  CloseGraph;
end.