unit TGSprite;

interface

uses TGGlob;

type
  TSprDta = record
    SprPtr: array [1..20] of Pointer; { 㪠⥫  ⨭ }
    Sz: array [1..20] of Word;        { ࠧ ⨭       }
    NOfPhase: Word;                   { ᫮ ⨭        }
  end;

procedure LoadSprite (var S: TSprDta; FileName: String);
procedure FreeSprite (var S: TSprDta);
procedure PutSprite (X, Y: Integer; SPoi: Pointer);
procedure PutVPSprite (X, Y: Integer; SPoi: Pointer);
procedure SetSpriteViewPort (X1, Y1, X2, Y2: Integer);

implementation

procedure LoadSprite (var S: TSprDta; FileName: String);
var
  SprFile: File;
  NB, NumRead: Word;
  i: Integer;
begin
  Assign (SprFile, FileName);
  Reset (SprFile, 1);
  i := 0;
  with S do
    repeat
      BlockRead (SprFile, NB, 2, NumRead);
      if (NumRead <> 2) then begin
        NofPhase := i;
        Close (SprFile);
        Exit;
      end;
      Inc (i);
      Sz[i] := NB-2;
      GetMem (SprPtr[i], NB-2);
      BlockRead (SprFile, SprPtr[i]^, NB-2, NumRead);
    until (NumRead <> NB-2);
end;

procedure FreeSprite (var S: TSprDta);
var
  i: Byte;
begin
  with S do
    for i:=1 to NOfPhase do
      FreeMem (SprPtr[i], Sz[i]);
end;

procedure PutSprite (X, Y: Integer; SPoi: Pointer); assembler;
  var
    SLength, SWidth: Byte;
    LenCnt, WidCnt: Byte;
    PlnCnt: Byte;
    ForDS: Word;
  asm
    mov  ForDS, ds
    { ⠢塞   }
    mov  ax, ActPg
    mov  si, word ptr SPoi
    mov  ds, word ptr SPoi[2]
    mov  bx, 800h
    mul  bx
    add  ax, 0A000h
    mov  es, ax
    mov  ax, 80
    mov  bx, Y
    mul  bx
    mov  bx, ax

    { 塞   ॣ 饭 }
    mov  ax, X
    mov  cl, 3
    shr  ax, cl
    mov  di, ax    { ࠭塞 ᫮ 楫   DI }
    push di
    mov  cl, 3
    shl  ax, cl
    mov  cx, X
    sub  cx, ax    { 砥 ⮪   }
    mov  ch, 08h   {  CH 㤥 ᤢ, ᫨   }
    sub  ch, cl    {  CL 㤥 ᤢ, ᫨  ࠢ }

    { ⠭ 饭 }
    mov  al, 3
    mov  dx, 3CEh
    out  dx, al
    mov  al, cl
    inc  dx
    out  dx, al

    { ⠢塞   }
    mov  al, byte ptr ds:[si]
    mov  SLength, al
    inc  si
    mov  al, byte ptr ds:[si]
    mov  SWidth, al
    inc  si
    mov  WidCnt, 1

@@NxtStr:
    pop  di
    push di
    mov  LenCnt, 1

@@NxtByte:
    { 뢥   }
    mov  al, 2
    mov  dx, 3C4h
    out  dx, al
    mov  al, 0FFh
    inc  dx
    out  dx, al
    { 뢠   }
    mov  al, 8
    mov  dx, 3CEh
    out  dx, al
    mov  al, 0FFh
    inc  dx
    out  dx, al
    mov  al, byte ptr es:[bx+di]

    { 塞   ॣ ᪨ ⮢ 1   ⨭ }
    mov  al, 8
    mov  dx, 3CEh
    out  dx, al
    mov  al, byte ptr ds:[si]
    shr  al, cl
    inc  dx
    out  dx, al

    { 뫠   4 ᪮⥩ }
    mov  PlnCnt, 00000001b
    inc  si
@@NxtPln1:
    mov  al, 2
    mov  dx, 3C4h
    out  dx, al
    mov  al, PlnCnt
    inc  dx
    out  dx, al
    mov  al, byte ptr ds:[si]
    mov  byte ptr es:[bx+di], al
    shl  PlnCnt, 1
    inc  si
    cmp  PlnCnt, 00010000b
    jl   @@NxtPln1
    sub  si, 5
    inc  di

    { 뢥   }
    mov  al, 2
    mov  dx, 3C4h
    out  dx, al
    mov  al, 0FFh
    inc  dx
    out  dx, al
    { 뢠   }
    mov  al, 8
    mov  dx, 3CEh
    out  dx, al
    mov  al, 0FFh
    inc  dx
    out  dx, al
    mov  al, byte ptr es:[bx+di]

    { 塞   ॣ ᪨ ⮢ 2   ⨭ }
    mov  al, 8
    mov  dx, 3CEh
    out  dx, al
    mov  al, byte ptr ds:[si]
    xchg ch, cl
    shl  al, cl
    inc  dx
    out  dx, al
    xchg ch, cl

    { 뫠   4 ᪮⥩ }
    mov  PlnCnt, 00000001b
    inc  si
@@NxtPln2:
    mov  al, 2
    mov  dx, 3C4h
    out  dx, al
    mov  al, PlnCnt
    inc  dx
    out  dx, al
    mov  al, byte ptr ds:[si]
    mov  byte ptr es:[bx+di], al
    shl  PlnCnt, 1
    inc  si
    cmp  PlnCnt, 00010000b
    jl   @@NxtPln2

    { 騥 8 祪 }
    inc  LenCnt
    mov  al, LenCnt
    cmp  al, SLength
    jg   @@TestNxtStr
    jmp  @@NxtByte

@@TestNxtStr:
    {  ப }
    add  bx, 80
    inc  WidCnt
    mov  al, WidCnt
    cmp  al, SWidth
    jg   @@Done
    jmp  @@NxtStr

@@Done:
    pop  di
    { ࠥ 饭 }
    mov  al, 3
    mov  dx, 3CEh
    out  dx, al
    mov  al, 0
    inc  dx
    out  dx, al
    { 뢥   }
    mov  al,2
    mov  dx,3C4h
    out  dx, al
    mov  al, 0FFh
    inc  dx
    out  dx, al
    { 뢠   }
    mov  al, 8
    mov  dx, 3CEh
    out  dx, al
    mov  al, 0FFh
    inc  dx
    out  dx, al
    mov  ds, ForDS
  end;

procedure PutVPSprite (X, Y: Integer; SPoi: Pointer);
  var
    L, W: Byte;
    LenCnt, WidCnt: Byte;
    SprMap: Byte;
    PlnCnt: Byte;
    ForDS: Word;
    IniBX, IniDI, dX: Integer;
  begin
    if X<0 then dX := (-X div 8)+1
    else dX := 0;
    X := X+dX*8;
    IniDI := Integer(X SHR 3) - dX;
    IniBX := 0+Y*80;
    asm
      mov  ForDS, ds
      { ⠢塞   }
      mov  ax, word ptr ds:ActPg
      mov  si, word ptr SPoi
      mov  ds, word ptr SPoi[2]
      mov  bx, 800h
      mul  bx
      add  ax, 0A000h
      mov  es, ax
      mov  bx, IniBX
      push IniDI

      { 塞   ॣ 饭 }
      mov  ax, X
      mov  cl, 3
      shr  ax, cl
      mov  cl, 3
      shl  ax, cl
      mov  cx, X
      sub  cx, ax    { 砥 ⮪   }
      mov  ch, 08h   {  CH 㤥 ᤢ, ᫨   }
      sub  ch, cl    {  CL 㤥 ᤢ, ᫨  ࠢ }

      { ⠭ 饭 }
      mov  al, 3
      mov  dx, 3CEh
      out  dx, al
      mov  al, cl
      inc  dx
      out  dx, al

      { ⠢塞   }
      mov  al, byte ptr ds:[si]
      mov  L, al
      inc  si
      mov  al, byte ptr ds:[si]
      mov  W, al
      inc  si
      mov  WidCnt, 1

@@NxtStr:
      pop  di
      push di
      mov  LenCnt, 1

@@NxtByte:
      { 뢥   }
      mov  al, 2
      mov  dx, 3C4h
      out  dx, al
      mov  al, 0FFh
      inc  dx
      out  dx, al

      { 뢠   }
      mov  al, 8
      mov  dx, 3CEh
      out  dx, al
      mov  al, 0FFh
      inc  dx
      out  dx, al
      mov  al, byte ptr es:[bx+di]

      { 塞   ॣ ᪨ ⮢ 1   ⨭ }
      push ds
      mov  ds, ForDS
      mov  SprMap, 0FFh
      cmp  di, XmaxSpr
      jle  @@Xmax1
      pop  ds
      jmp  @@NxtPart
@@Xmax1:
      jne  @@TstXmin1
      mov  al, MaxSprMap
      and  SprMap, al
@@TstXmin1:
      cmp  di, XminSpr
      jge  @@Xmin1
      pop  ds
      jmp  @@NxtPart
@@Xmin1:
      jne  @@TstYmax1
      mov  al, MinSprMap
      and  SprMap, al
@@TstYmax1:
      cmp  bx, YmaxSpr
      jle  @@TstYmin1
      pop  ds
      jmp  @@NxtPart
@@TstYmin1:
      cmp  bx, YminSpr
      jge  @@Ok1
      pop  ds
      jmp  @@NxtPart
@@Ok1:
      pop  ds
      mov  al, 8
      mov  dx, 3CEh
      out  dx, al
      mov  al, byte ptr ds:[si]
      shr  al, cl
      and  al, SprMap
      inc  dx
      out  dx, al

      { 뫠   4 ᪮⥩ }
      mov  PlnCnt, 00000001b
      inc  si
@@NxtPln1:
      mov  al, 2
      mov  dx, 3C4h
      out  dx, al
      mov  al, PlnCnt
      inc  dx
      out  dx, al
      mov  al, byte ptr ds:[si]
      mov  byte ptr es:[bx+di], al
      shl  PlnCnt, 1
      inc  si
      cmp  PlnCnt, 00010000b
      jl   @@NxtPln1
      sub  si, 5
@@NxtPart:
      inc  di

      { 뢥   }
      mov  al, 2
      mov  dx, 3C4h
      out  dx, al
      mov  al, 0FFh
      inc  dx
      out  dx, al
      { 뢠   }
      mov  al, 8
      mov  dx, 3CEh
      out  dx, al
      mov  al, 0FFh
      inc  dx
      out  dx, al
      mov  al, byte ptr es:[bx+di]

      { 塞   ॣ ᪨ ⮢ 2   ⨭ }
      push ds
      mov  ds, ForDS
      mov  SprMap, 0FFh
      cmp  di, XmaxSpr
      jle  @@Xmax2
      pop  ds
      jmp  @@Nxt8Pnt
@@Xmax2:
      jne  @@TstXmin2
      mov  al, MaxSprMap
      and  SprMap, al
@@TstXmin2:
      cmp  di, XminSpr
      jge  @@Xmin2
      pop  ds
      jmp  @@Nxt8Pnt
@@Xmin2:
      jne  @@TstYmax2
      mov  al, MinSprMap
      and  SprMap, al
@@TstYmax2:
      cmp  bx, YmaxSpr
      jle  @@TstYmin2
      pop  ds
      jmp  @@Nxt8Pnt
@@TstYmin2:
      cmp  bx, YminSpr
      jge  @@Ok2
      pop  ds
      jmp  @@Nxt8Pnt
@@Ok2:
      pop  ds
      mov  al, 8
      mov  dx, 3CEh
      out  dx, al
      mov  al, byte ptr ds:[si]
      xchg ch, cl
      shl  al, cl
      and  al, SprMap
      inc  dx
      out  dx, al
      xchg ch, cl

      { 뫠   4 ᪮⥩ }
      mov  PlnCnt, 00000001b
      inc  si
@@NxtPln2:
      mov  al, 2
      mov  dx, 3C4h
      out  dx, al
      mov  al, PlnCnt
      inc  dx
      out  dx, al
      mov  al, byte ptr ds:[si]
      mov  byte ptr es:[bx+di], al
      shl  PlnCnt, 1
      inc  si
      cmp  PlnCnt, 00010000b
      jl   @@NxtPln2
      jmp  @@NormN8P

@@Nxt8Pnt:
      add  si, 5
@@NormN8P:
      { 騥 8 祪 }
      inc  LenCnt
      mov  al, LenCnt
      cmp  al, L
      jg   @@TestNxtStr
      jmp  @@NxtByte

@@TestNxtStr:
      {  ப }
      add  bx, 80
      inc  WidCnt
      mov  al, WidCnt
      cmp  al, W
      jg   @@Done
      jmp  @@NxtStr

@@Done:
      pop  di
      { ࠥ 饭 }
      mov  al, 3
      mov  dx, 3CEh
      out  dx, al
      mov  al, 0
      inc  dx
      out  dx, al
      { 뢥   }
      mov  al, 2
      mov  dx, 3C4h
      out  dx, al
      mov  al, 0FFh
      inc  dx
      out  dx, al
      { 뢠   }
      mov  al, 8
      mov  dx, 3CEh
      out  dx, al
      mov  al, 0FFh
      inc  dx
      out  dx, al
      mov  ds, ForDS
    end;
  end;

procedure SetSpriteViewPort (X1, Y1, X2, Y2: Integer);
begin
  XminSpr := (X1 div 8);
  MinSprMap := not (255 SHL ((XminSpr+1)*8-X1));
  XmaxSpr := (X2 div 8);
  MaxSprMap := 255 SHL ((XmaxSpr+1)*8-X2-1);
  YminSpr := Y1*80;
  YmaxSpr := Y2*80;
end;

end.