unit TGSprMo;

interface

{$F+}
uses TGGlob,
     Graph, Crt, Dos,
     Mouse, TGGraph, TGSprite;

procedure SprMoInit;
procedure SprMoClose;
procedure SprMoSwitchPg;
procedure SprMoListPg;
procedure SprMoShow;
procedure SprMoHide;

const
  SprMoVis: Boolean = FALSE;
  SprMoPhase: Word = 1;
  SprMoXShift: Integer = 0;
  SprMoYShift: Integer = 0;

  HotMoX: Integer = 320;
  HotMoY: Integer = 100;

type
  TSave = record
    BkGrPtr: Pointer;
    Sz: Word;
    MinX, MinY, MaxX, MaxY : Integer;
  end;
  TSBG = array [0..1] of TSave;
  Head = record
    X: Byte;
    Y: Byte;
  end;
  PHead = ^Head;

var
  SprMoXAct, SprMoYAct: Integer;
  SprMo: TSprDta;
  SprMoSBG: TSBG;

implementation

procedure FreeSprMo;
var
  i: Byte;
begin
  FreeMem (SprMoSBG [0].BkGrPtr, 2048);
  FreeMem (SprMoSBG [1].BkGrPtr, 2048);
end;

procedure SprMoSaveBkGr;
var
  SaveActPg: Byte;
begin
  SaveActPg := ActPg;
  ActPg := VisPg;
  with SprMoSBG [VisPg] do begin
    MaxX := SprMoXAct + 8 * PHead (SprMo.SprPtr[SprMoPhase])^.X;
    MaxY := SprMoYAct + PHead (SprMo.SprPtr[SprMoPhase])^.Y;
    MinX := SprMoXAct;
    MinY := SprMoYAct;
    if (MinX < 0) then MinX := 0;
    if (MinX > 639) then MinX := 639;
    if (MaxX < 0) then MaxX := 0;
    if (MaxX > 639) then MaxX := 639;
    if (MinY < 0) then MinY := 0;
    if (MinY > 349) then MinY := 349;
    if (MaxY < 0) then MaxY := 0;
    if (MaxY > 349) then MaxY := 349;
    FastGetImage (MinX, MinY, MaxX, MaxY, BkGrPtr);
  end;
  ActPg := SaveActPg;
end;

procedure SprMoPutBkGr;
var
  SaveActPg: Byte;
begin
  SaveActPg := ActPg;
  ActPg := VisPg;
  with SprMoSBG [VisPg] do
    FastPutImage (MinX, MinY, BkGrPtr);
  ActPg := SaveActPg;
end;

procedure SprMoDraw;
var
  SaveActPg: Byte;
begin
  SaveActPg := ActPg;
  ActPg := VisPg;
  PutVPSprite (SprMoXAct, SprMoYAct, SprMo.SprPtr [SprMoPhase]);
  ActPg := SaveActPg;
end;

procedure DrawMouse;
begin
  SprMoXAct := HotMoX - SprMoXShift;
  SprMoYAct := HotMoY - SprMoYShift;
  SprMoPutBkGr;
  SprMoSaveBkGr;
  SprMoDraw;
end;

procedure SprMoSwitchPg;
begin
  if SprMoVis then begin
    SprMoMoves := FALSE;
    with SprMoSBG [ActPg] do begin
      MaxX := SprMoXAct + 8 * PHead (SprMo.SprPtr[SprMoPhase])^.X;
      MaxY := SprMoYAct + PHead (SprMo.SprPtr[SprMoPhase])^.Y;
      MinX := SprMoXAct;
      MinY := SprMoYAct;
      if (MinX < 0) then MinX := 0;
      if (MinX > 639) then MinX := 639;
      if (MaxX < 0) then MaxX := 0;
      if (MaxX > 639) then MaxX := 639;
      if (MinY < 0) then MinY := 0;
      if (MinY > 349) then MinY := 349;
      if (MaxY < 0) then MaxY := 0;
      if (MaxY > 349) then MaxY := 349;
      FastGetImage (MinX, MinY, MaxX, MaxY, BkGrPtr);
      PutVPSprite (SprMoXAct, SprMoYAct, SprMo.SprPtr[SprMoPhase]);
      SwitchPg;
      FastPutImage (MinX, MinY, BkGrPtr);
    end;
    SprMoMoves := TRUE;
  end
  else SwitchPg;
end;

procedure SprMoListPg;
var
  MinX, MinY, MaxX, MaxY: Integer;
begin
  if SprMoVis then begin
    SprMoMoves := FALSE;
    with SprMoSBG [ActPg] do begin
      MaxX := SprMoXAct + 8 * PHead (SprMo.SprPtr[SprMoPhase])^.X;
      MaxY := SprMoYAct + PHead (SprMo.SprPtr[SprMoPhase])^.Y;
      MinX := SprMoXAct;
      MinY := SprMoYAct;
      if (MinX < 0) then MinX := 0;
      if (MinX > 639) then MinX := 639;
      if (MaxX < 0) then MaxX := 0;
      if (MaxX > 639) then MaxX := 639;
      if (MinY < 0) then MinY := 0;
      if (MinY > 349) then MinY := 349;
      if (MaxY < 0) then MaxY := 0;
      if (MaxY > 349) then MaxY := 349;
      FastGetImage (MinX, MinY, MaxX, MaxY, BkGrPtr);
      PutVPSprite (SprMoXAct, SprMoYAct, SprMo.SprPtr[SprMoPhase]);
      ListPg;
      FastPutImage (MinX, MinY, BkGrPtr);
    end;
    SprMoMoves := TRUE;
  end
  else ListPg;
end;

procedure SprMoHide;
begin
  if SprMoVis and SprMoOK then begin
    SprMoMoves := FALSE;
    SprMoPutBkGr;
    SprMoVis := FALSE;
  end;
end;

procedure SprMoShow;
begin
  if not SprMoVis and SprMoOK then begin
    SprMoXAct := HotMoX - SprMoXShift;
    SprMoYAct := HotMoY - SprMoYShift;
    SprMoSaveBkGr;
    SprMoDraw;
    SprMoMoves := TRUE;
    SprMoVis := TRUE;
  end;
end;

procedure SprMoClose;
var
  i: Integer;
begin
  asm
    mov  ax, 000Ch
    mov  cx, 0
    int  33h
  end;
  SprMoHide;
  FreeSprite (SprMo);
  SprMoOK := FALSE;
end;

procedure MoInt; assembler;
asm
  mov  ax, seg @Data
  mov  ds, ax
  mov  HotMoX, cx
  mov  HotMoY, dx
  cmp  SprMoMoves, 0
  je   @@Exit
  call DrawMouse;
@@Exit:
  ret
end;

procedure SprMoInit;
var
  Butt: Word;
begin
  MoInit;
  if not (MoError = moOk) then Exit;
  MoState (Butt, HotMoX, HotMoY);
  TGetMem (SprMoSBG [0].BkGrPtr, 2048);
  TGetMem (SprMoSBG [1].BkGrPtr, 2048);
  SprMoOK := TRUE;
  SprMoSaveBkGr;
  DrawMouse;
  SprMoMoves := TRUE;
  SprMoVis := TRUE;
  asm
    mov  ax, 000Ch
    mov  cl, 1
    push cs
    pop  es
    mov  dx, offset MoInt
    int  33h
  end;
end;

end.


